<#--########################################################################
  Warning! Do not delete this header, it is used by StrategyQuant to get
  information about this code generator.

  <name>Expert Advisor for JForex (*.java)</name>
  <id>jforex</id>
  <extensionName>JForex Expert Advisor</extensionName>
  <extension>java</extension>
  <description>Saves strategy as JForex code</description>
#########################################################################-->
<@compress single_line=true>
<#include "/global/globalFunctions.inc">
<#include "/JForex/Functions.inc">
<#include "/JForex/Blocks.inc">
<#include "/JForex/Parameters.inc">
<#include "/JForex/TradingOptions.inc">
<#include "/JForex/MoneyManagement.inc">
<#include "/JForex/Size.inc">
<#include "/JForex/ATM.inc">
<#assign ExitMethodsList = ["StopLoss", "ProfitTarget", "MoveSL2BE", "TrailingStop", "ExitAfterBars"] />
<@getAllMagicNumbers />
</@compress>
//------------------------------------------------------------------
// Java Code for JForex of ${getOptions("StrategyName")}
//
//   Generated by StrategyQuant ${getOptions("Version")}
//   at ${getOptions("Date")}
//
//   <@printBacktestInfo /> 
//  
//+------------------------------------------------------------------+

package jforex;

import java.io.*;
import java.util.*;
import java.awt.Color;
import java.awt.Toolkit;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.HashMap;
import java.util.Map;
import java.util.Calendar;
import java.util.Date;
import java.text.SimpleDateFormat;

import com.dukascopy.api.IIndicators.AppliedPrice;
import static com.dukascopy.api.IIndicators.AppliedPrice.*;
import com.dukascopy.api.IEngine.OrderCommand;
import static com.dukascopy.api.IEngine.OrderCommand.*;
import com.dukascopy.api.IOrder.State;
import static com.dukascopy.api.IOrder.State.*;
import static com.dukascopy.api.OfferSide.*;
import com.dukascopy.api.IIndicators.MaType;
import static com.dukascopy.api.IIndicators.MaType.*;
import com.dukascopy.api.Unit;
import static com.dukascopy.api.Unit.*;

import com.dukascopy.api.*;

public class ${getOptions("StrategyClassName", "Strategy")} implements IStrategy {
    private IEngine engine;
    private IConsole console;
    private IHistory history;
    private IContext context;
    private IIndicators indicators;
    private IUserInterface userInterface;

	private IOrder order;
	private List<IOrder> orders;
	private Instrument instrument;
	private Period period;
	private OrderCommand orderType;
	private IBar bar;
	private int counter = 1; 
	private String ticket;
	private Calendar calendar = Calendar.getInstance();
	private long time;
	private double amount;
	private double initialBalance = 0;
	
	private boolean openingOrdersAllowed = true;
		
	private static final int SLPTTYPE_RANGE = 0;
	private static final int SLPTTYPE_LEVEL = 1;
	
	private static final int MODE_SMA = 0; //Simple averaging
	private static final int MODE_EMA = 1; //Exponential averaging
	private static final int MODE_SMMA = 2; //Smoothed averaging
	private static final int MODE_LWMA = 3; //Linear-weighted averaging
	
	private static final int MODE_MAIN = 0;
	private static final int MODE_SIGNAL = 1;
	private static final int MODE_PLUSDI = 1;
	private static final int MODE_MINUSDI = 2;
	
	@Configurable("Instrument")
    public Instrument selectedInstrument = Instrument.EURUSD;
    @Configurable("Period")
    public Period selectedPeriod = Period.DAILY;
	@Configurable(value = "Custom Comment")
	public String CustomComment = "<@printStrategyName />";

	//------------------------------------------------------------------+
	// -- SQ internal variables
	//------------------------------------------------------------------+
	private int sqMaxEntrySlippage = 5;          //Max tolerated entry slippage in pips. Zero means unlimited slippage
	private int sqMaxCloseSlippage = 0;          //Max tolerated close slippage in pips. Zero means unlimited slippage       
	private boolean autoCorrectMaxSlippage = true;  //If set to true, it will automatically adjust max slippage according to symbol digits (*10 for 3 and 5 digit symbols)  
		
	private boolean cond[] = new boolean[100];	
		
	private Map<String, Double> globalVariables = new HashMap<String, Double>();
	private Map<Integer, Period> periodsMap = new HashMap<Integer, Period>();
	private Map<String, Instrument> instrumentsMap = new HashMap<String, Instrument>();
		
	private int errors = 0;	
		
	<@jfPrintInputs />

	<@jfPrintVars />
	
	<@jfPrintSubcharts />
	
	@Override
    public void onStart(IContext context) throws JFException {
        this.engine = context.getEngine();
        this.console = context.getConsole();
        this.history = context.getHistory();
        this.context = context;
        this.indicators = context.getIndicators();
        this.userInterface = context.getUserInterface();
		
		print("--------------------------------------------------------");
		print("Starting the EA");
		print("--------------------------------------------------------");
			
        //subscribe an instrument:
        Set<Instrument> instruments = new HashSet<Instrument>();
        instruments.add(selectedInstrument);                     
        context.setSubscribedInstruments(instruments, true);
		
		initialBalance = context.getAccount().getBalance();
		
		print("Initial balance: ", initialBalance);
		
		try {
			print("Registering custom indicators located in ...\\JForex\\Strategies\\files folder");
			File f = context.getFilesDir();
			
			FilenameFilter filter = new FilenameFilter() {
				@Override
				public boolean accept(File f, String name) {
					return name.endsWith(".jfx");
				}
			};
			File[] files = f.listFiles(filter);
			for (int i = 0; i < files.length; i++) {
				File fCustomIndy = files[i];
				
				print(String.format("Registering custom indicator %s", fCustomIndy.getAbsolutePath()));
				this.indicators.registerCustomIndicator(fCustomIndy);
			}
		} catch(Exception e) {
			print("Error while loading Custom indicators. " + e.getMessage());
		}
    }

	@Override
    public void onAccount(IAccount account) throws JFException {
    }

	@Override
    public void onMessage(IMessage message) throws JFException {
		String reasons = "";
        for(IMessage.Reason reason : message.getReasons()) {
            reasons+=", "+reason.toString();
        }
	
		switch(message.getType()){
			case ORDER_SUBMIT_OK : 
				print("Order opened: " + message.getOrder(), reasons);
				break;
			case ORDER_SUBMIT_REJECTED : 
				print("Order open failed: " + message.getOrder(), reasons);
				break;
			case ORDER_FILL_OK : 
				print("Order filled: " + message.getOrder(), reasons);
				break;
			case ORDER_FILL_REJECTED : 
				print("Order cancelled: " + message.getOrder(), reasons);
				break;
			default:
				if(message.getOrder() == null) {
					print(message.getContent(), reasons);
				} else {
					print(message.getContent() + ", order: " + message.getOrder().getLabel(), reasons);
				}
				break;
		}
    }

	@Override
    public void onStop() throws JFException {
		print("Strategy is going to close.");
		
		//close all existing orders
		print("Closing all existing orders");
		for (IOrder order : engine.getOrders()) {
				order.close();
		}
		
		if(errors > 0) {
			print(String.format("There were some errors (%d) while running the strategy. Please check the log for more details.", errors));
		}
		
		Toolkit.getDefaultToolkit().beep();
    }

	@Override
    public void onTick(Instrument instrument, ITick tick) throws JFException {
		//openingOrdersAllowed = sqHandleTradingOptions();	
    }
    
	@Override
    public void onBar(Instrument instrument, Period period, IBar askBar, IBar bidBar) throws JFException {
		try {
			if(instrument != this.selectedInstrument || period != this.selectedPeriod){
				return;
			}
			
			time = history.getStartTimeOfCurrentBar(instrument, period);
			
			calendar.setTimeInMillis(time);
			//if(calendar.get(Calendar.YEAR) < 2019) return;
			
			if(context.getDataService().isOfflineTime(time)) return;
			
			sqManageOrders();
		
			openingOrdersAllowed = sqHandleTradingOptions();
		
			<#if getRulesCountForEvent("OnBarUpdate") gt 0 >
				<@printRulesForEvent "OnBarUpdate" />
			</#if>
		} catch(Exception e) {
			print(String.format("ERROR: %s", e.getMessage()));			
			errors++;

			throw e;
		}
    }
	
//------------------------------------------------------------------

private boolean sqHandleTradingOptions() throws JFException {
	<@printTradingOptionsHandlers />
}   
	
	
//------------------------------------------------------------------

private boolean checkMagicNumber(int magicNo){
	<#list MagicNumbersList as magicNumber>
	if(magicNo == ${magicNumber}){
		 return true;
	}
	</#list>
	
	return false;
}
		
//----------------------------------------------------------------------------

private void sqResetGlobalVariablesForTicket(String ticket) throws JFException {
   sqSetGlobalVariable(ticket, "sqOrderExpiration", 0);
   sqSetGlobalVariable(ticket, "sqOrderOpenTime", getCurrentTime());

  <#list ExitMethodsList as exitMethod>
    <@printExitMethodReset exitMethod />
  </#list>
  
}
		
//------------------------------------------------------------------	
	
	<#include "/JForex/SQ.java">
	
	<#include "/JForex/SQIndicators.java">
	
	<@printTradingOptionsClasses />
	
	<@printMoneyManagementClass />
	
//------------------------------------------------------------------
//------------------------------------------------------------------
// ExitMethods includes
//------------------------------------------------------------------
//------------------------------------------------------------------

<#list ExitMethodsList as exitMethod>
   <@printExitMethodInclude exitMethod />
</#list>

//------------------------------------------------------------------

private double sqGetIndicatorByIdentification(String idHash, int shift) throws JFException {
   <@printIndicatorsUsedInFunctions  />

   return 0;
}


//------------------------------------------------------------------

private double sqGetValueByIdentification(int idHash, Instrument instrument) throws JFException {
   <@printValuesUsedInExitMethods />

   return 0;
}
	
}